#!/usr/bin/env python3

from natsort import natsorted

from stacked_cores_52xx import *
from stacked_cores_52xx_plotters import *


or_gates = read_db(lambda name: name.startswith("52-"))

sweep_a0 = lambda a1, points=101: [(unit_to_m(x/(points-1)), a1, None, None) for x in range(points)]
sweep_a1 = lambda a0, points=101: [(a0, unit_to_m(x/(points-1)), None, None) for x in range(points)]


for name, meas in natsorted(or_gates.items()):
    trace = eval_series(meas, sweep_a1(-17000), extract_52xx_tx)
    plot(f"{name}", "a1", trace)
    plot_slope(f"slope {name}", "a1", trace)
