#!/usr/bin/env python3

from stacked_cores_52xx import *
from stacked_cores_52xx_plotters import *

def extract_53xx_tx(meas_rows: list) -> tuple:
    """
    extracts a flat tuple of input/output M mappings from a 53xx run
    """
    return (meas_rows[1].m[0], meas_rows[0].m[1], meas_rows[0].m[2], meas_rows[1].m[3])

sweep_buf_inputs = lambda offset=0, points=101: [(None, m, -m + offset, None) for m in sweep_1d(points)]
sweep_m1 = lambda m2, points=101: [(None, m, m2, None) for m in sweep_1d(points)]

buf_gates = read_db(lambda name: name.startswith("53-buf-no_inp_couple-"))

for name, meas in natsorted(buf_gates.items()):
    print(name)
    # normal M2 = -M1 sweep
    trace = eval_series(meas, sweep_buf_inputs(points=41), extract_53xx_tx, y_idx=0)
    plot(name, "a0", trace)
    plot_slope(f"slope {name}", "a0", trace)

    # M2 = 0.25 - M1 shifted sweep
    # trace = eval_series(meas, sweep_buf_inputs(8500), extract_53xx_tx, y_idx=0)
    # plot(f"In=0.25-Ip {name}", "a0", trace)
    # plot_slope(f"slope In=0.25-Ip {name}", "a0", trace)

    # M2 fixed at 0.0 while M1 sweeps
    # trace = eval_series(meas, sweep_m1(0.0), extract_53xx_tx, y_idx=0)
    # plot(f"In=0 {name}", "a0", trace)
    # plot_slope(f"slope In=0 {name}", "a0", trace)
