#!/usr/bin/env python3

from natsort import natsorted

from stacked_cores_52xx import *
from stacked_cores_52xx_plotters import *


def extract_54xx_tx(meas_rows: list) -> tuple:
    """
    extracts a flat tuple of input/output M mappings from a 54xx run
    """
    return (meas_rows[0].m[0], meas_rows[2].m[0])


split_gates = read_db(lambda name: name.startswith("54-"))

sweep_input = lambda points=101: [( unit_to_m(x/(points-1)), None ) for x in range(points)]


for name, meas in natsorted(or_gates.items()):
    trace = eval_series(meas, sweep_input(), extract_54xx_tx)
    plot(f"{name}", "a1", trace)
    plot_slope(f"slope {name}", "a1", trace)
