#!/usr/bin/env python3

from natsort import natsorted

from stacked_cores_52xx import *
from stacked_cores_52xx_plotters import *


def extract_56xx_tx(meas_rows: list) -> tuple:
    """
    extracts a flat tuple of input/output M mappings from a 56xx run
    """

    return (
        meas_rows[0].m[0],  # input
        meas_rows[0].m[1],  # input
        meas_rows[1].m[2],  # output
        meas_rows[1].m[3],  # output
        meas_rows[0].m[4],  # input
        meas_rows[0].m[5],  # input
    )


buf_gates = read_db(lambda name: name.startswith("56-"))

sweep_buf_inputs = lambda points=101: [(m, m, None, None, -m, -m) for m in sweep_1d(points)]


for name, meas in natsorted(buf_gates.items()):
    trace = eval_series(meas, sweep_buf_inputs(), extract_56xx_tx, y_idx=2)
    plot(f"{name}", "a1", trace)
    plot_slope(f"slope {name}", "a1", trace)
