#!/usr/bin/env python3

from natsort import natsorted

from stacked_cores_52xx import *
from stacked_cores_52xx_plotters import *


def extract_57xx_tx(meas_rows: list) -> tuple:
    """
    extracts a flat tuple of input/output M mappings from a 57xx run
    """

    return (
        meas_rows[0].m[0],  # input
        meas_rows[1].m[1],  # output
        meas_rows[0].m[2],  # input
        meas_rows[0].m[3],  # input
        meas_rows[1].m[4],  # output
        meas_rows[0].m[5],  # input
    )


# buf_gates = read_db(lambda name: name.startswith("57-"))
buf_gates = read_db(lambda name: name.startswith("57-buf-1p-2n-"))

sweep_buf_inputs = lambda points=101: [(m, None, m, -m, None, -m) for m in sweep_1d(points)]
sweep_pos_input = lambda mneg, points=101: [(m, None, m, mneg, None, mneg) for m in sweep_1d(points)]
sweep_2n1p_input = lambda points=101: [(m, None, None, -m, None, -m) for m in sweep_1d(points)]


for name, meas in natsorted(buf_gates.items()):
    # trace = eval_series(meas, sweep_buf_inputs(41), extract_57xx_tx, y_idx=1)
    # trace = eval_series(meas, sweep_pos_input(0, 41), extract_57xx_tx, y_idx=1)
    trace = eval_series(meas, sweep_2n1p_input(41), extract_57xx_tx, y_idx=1)
    plot(f"{name}", "a1", trace)
    plot_slope(f"slope {name}", "a1", trace)
