#!/usr/bin/env python3

from natsort import natsorted

from stacked_cores_52xx import *
from stacked_cores_52xx_plotters import *


def extract_60xx_tx(meas_rows: list) -> tuple:
    """
    extracts a flat tuple of input/output M mappings from a 60xx run
    """

    return (
        meas_rows[0].m[0],  # input
        meas_rows[1].m[2],  # output
        # meas_rows[1].m[1],  # intermediate
        # meas_rows[1].m[3],  # intermediate
    )


buf_gates = read_db(lambda name: name.startswith("60-"))

sweep_inv_input = lambda points=101: [(m, None) for m in sweep_1d(points)]


for name, meas in natsorted(buf_gates.items()):
    trace = eval_series(meas, sweep_inv_input(41), extract_60xx_tx, y_idx=1)
    plot(f"{name}", "M", trace)
    plot_slope(f"slope {name}", "M", trace)
