//! extracts Measurements from rendered .bc files and dumps them into a CSV

use coremem_post::{Loader, LoaderCache};
use std::path::PathBuf;
use structopt::StructOpt;

#[derive(Debug, StructOpt)]
struct Opt {
    directory: PathBuf,
}

fn main() {
    let opt = Opt::from_args();
    let loader = Loader::new(opt.directory);
    let mut cache = LoaderCache::new(loader, 2, 2);
    
    let mut frame = cache.load_first();
    for meas in frame.measurements() {
        print!("\"{}\",", meas.name());
    }
    println!("");

    loop {
        for meas in frame.measurements() {
            print!("\"{}\",", meas.machine_readable().replace(",", "\\,"));
        }
        println!("");

        let next_frame = cache.load_rel(&*frame, 1);
        if frame.path() == next_frame.path() {
            break;
        }
        frame = next_frame;

    }
}
