//! "decimates" the binary rendered form of a simulation
//! by deleting all but every N rendered files
use coremem_post::Loader;
use std::fs;
use std::path::PathBuf;
use structopt::StructOpt;

#[derive(Debug, StructOpt)]
struct Opt {
    directory: PathBuf,
    factor: u32,
}

fn main() {
    let opt = Opt::from_args();
    let loader = Loader::new(opt.directory);
    let entries = loader.get_entries();
    for (i, entry) in entries.into_iter().enumerate() {
        if i % opt.factor as usize != 0 {
            fs::remove_file(entry.path()).unwrap();
        }
    }
}
